'use strict';
const request = require('request');
const fs = require('fs');
const dateFormat = require('dateformat');
const user = 'INSERT HERE THE SUPPLIER USER BY JUNIPER';
const pass = 'INSERT HERE THE SUPPLIER PASS BY JUNIPER';

var auxDate = new Date(new Date().setMonth(new Date().getMonth() + Math.floor((Math.random() * 6) + 1)));
var auxEndDate = (new Date(auxDate)).setDate(auxDate.getDate() + Math.floor((Math.random() * 6) + 1));

var StartDate = dateFormat(auxDate, 'yyyy-mm-dd');
var EndDate = dateFormat(auxEndDate, 'yyyy-mm-dd');

console.log('Dates searched: ' + StartDate + ' - ' + dateFormat(EndDate, 'yyyy-mm-dd'));

var body = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Header/><soapenv:Body><RentacarAvail xmlns="http://www.juniper.es/webservice/2007/"><RentacarAvailRQ Version="1.1" Language="EN"><Login Password="' + pass + '" Email="' + user + '"/><RentacarRequest><SearchSegmentsRentacar><SearchSegmentRentacar Start="' + StartDate + '" End="' + EndDate + '" OriginZone="15011" DestinationZone="15011" Hour="10:00:00" HourEnd="10:00:00"><CountryOfResidence>ES</CountryOfResidence><AgeDriver>30</AgeDriver></SearchSegmentRentacar></SearchSegmentsRentacar></RentacarRequest><AdvancedOptions><ShowBreakdownPrice>true</ShowBreakdownPrice><TimeOut>8000</TimeOut></AdvancedOptions></RentacarAvailRQ></RentacarAvail></soapenv:Body></soapenv:Envelope>';

request(
    {
        method: 'POST',
        uri: 'https://xml-uat.bookingengine.es/webservice/jp/operations/availtransactions.asmx',
        gzip: true,
        body: body,
        headers: {
            "User-Agent": "node-request",
            "Accept-Encoding": "gzip,deflate",
            "Host": "xml-uat.bookingengine.es",
            "Content-Type": "text/xml; charset=utf-8",
            "SOAPAction": "\"http://www.juniper.es/webservice/2007/RentacarAvail\""
        }
    }
    , function (error, response, body) {
        // body is the decompressed response body
        console.log('Juniper response saved to: Output.txt');

        fs.writeFile("output.txt", body, function (err) {
            if (err) {
                return console.log(err);
            }
        });
    }
)
    .on('data', function (data) {
        // decompressed data as it is received in chunks
    })
    .on('response', function (response) {
        // unmodified http.IncomingMessage object
        console.log(response.elapsedTime) ;
        response.on('data', function (data) {
            // compressed data as it is received
            console.log('Received chunk of ' + data.length + ' bytes of compressed data')
        })
    })